//
// Copyright (c) 2017 Alibaba Group Holding Ltd.
// All rights reversed.
//

/**
 * A simple broker implementation based on {@link EventEmitter}.
 */

var EventEmitter = require('events');

var Broker = function() {
    this.emitter = new EventEmitter();
}

Broker.prototype.subscribe = function(eventName, listener) {
    this.emitter.addListener(eventName, listener);
    return this;
}

Broker.prototype.unsubscribe = function(eventName, listener) {
    this.emitter.removeListener(eventName, listener);
    return this;
}

Broker.prototype.publish = function(eventName, args) {
    return this.emitter.emit(eventName, args);
}

module.exports = new Broker();
