var dbus_wrap = require("./build/Release/dbus_wrap.node");
/**
 * 新建一个Server的代理
 * @param {String} [bus_name] [dbus name]
 * @param {String} [object_path] [object path]
 * @param {String} [interface] [interface]
 * @type {dbus_wrap}
 */

// simulator Proxy
var proxy = new dbus_wrap.DBusProxy('iot.runtime.js', '/iot/runtime/js','iot.runtime.js');

// server_test proxy
// var proxy = new dbus_wrap.DBusProxy('com.ali.linkedge.server', '/com/ali/linkedge/server','com.ali.linkedge.server');

/**
 * sendSignal('signal_name', param1, param2, param3...)
 * signal_name: 信号名
 * param1, param2...: 参数， 目前只支持Number, Boolean, String 三种类型， 不支持Object
 */
console.log("===================signal test ===============");
var ss = { "key1": "value1", "key2": "value2"};
proxy.sendSignal('test_test', JSON.stringify(ss), 'ppp_ddd');
/**
 * callMethod: 调用Server提供的方法
 * @param  {[type]} 'get'       [method 名字]
 * @param  {[type]} 'property2' [参数1]
 * @param  {[type]} 'value' [参数2]
 * 如果有更多参数，依次列出
 * @param  {[type]} (result     [回调方法，调用对方方法时，获得的结果。 如果方法是void的，
 *                              这个参数可以忽略。 参数列表中只有最后一个Function是回调结果的。]
 */
console.log("===================callmethod test ===============");
var cm1 = {property: "OnOff"};
proxy.callMethod('get', JSON.stringify(cm1), (err, result) => {
    if (err) {
        console.log("proxy_test: 1:: some error happend: " + err.message);
    }
            // result 是一个String， 内容格式取决于Server的返回格式
    console.log("JS: call get method return: " + result);
});

// call sync method, if error happened, return value is undefined.
console.log("===================callMethodSync test ===============");
var value = { OnOff: "TurnItOff" };
var result = proxy.callMethodSync('set', JSON.stringify(value));
console.log("callMethodSync result: ", result);

// to check after set
console.log("===================callmethod test 222 ===============");
var cm2 = { property: "OnOff"};
proxy.callMethod('get', JSON.stringify(cm2), (err, result) => {
    if (err) {
        console.log("2:: some error happend: " + err.message);
    }
    console.log("JS: call get method after set, return: " + result);
});

// var proxy2 = new dbus_wrap.DBusProxy('iot.device.idle2', '/iot/device/idle2', 'iot.device.idle2');
// proxy2.sendSignal('test_test_2', 1, true, 'ppp_222');
// proxy2.callMethod('get', 'property2', 'value', (result) => {
//             console.log("JS2: call get method return: " + result);
// });
