var dbus_wrap = require("./build/Release/dbus_wrap.node");

/**
 * 建立一个Dbus server
 * @param {String} [bus_name] [bus name]
 * @param {String} [object_path] [object path]
 * @type {获得一个DBusServer的实例
 */
var server = new dbus_wrap.DBusServer("com.ali.linkedge.server", '/com/ali/linkedge/server');
/**
 * 添加过滤器，过滤器的格式需要符合DBUS的规范
 * @type {String}
 */
// server.addMatch("type='signal',path='/iot/device/id1024',interface='iot.device.id1024'");
// server.addMatch("type='signal',path='/com/ali/linkedge/server'");
server.addMatch("type='signal'");
server.addMatch("type='method_call',path='/com/ali/linkedge/server',interface='com.ali.linkedge.server'");
/**
 * 监听方法调用，名字为"method_call"
 * @param  {[type]} method    [调用的方法名]
 * @param  {[type]} args      [方法参数，String类型，内容为Array]
 * @param  {[type]} callback) {暂时不能使用，即不能异步将返回值传递给对方，只能同步return值给对方。}
 * @return {[type]}           [description]
 */
server.on("method_call", function(method, args) {
    console.log("iot.device.idle1: get method call: " + method, " args is: " + args);
    try {
        var obj = JSON.parse(args);
        for (var i of Object.keys(obj)) {
            console.log("arguemt: ", i);
        }
    } catch (e) {
        console.log("[server_test. method_call] args parse error: ", e.message);
    }

    return "Hello world"
});
/**
 * 监听signal，名字为"signal"
 * @param  {[type]} signal [发送过来的signal名字]
 * @param  {[type]} args)  { 参数，String类型， 内容为Array}
 * @return {[type]}        [description]
 */
server.on("signal", function(signal, sender, args) {
    console.log("iot.device.idle1: get SIGNAL: " + signal + ' sender: ' + sender + ' args: ' + args);
});
/**
 * 启动服务
 */
server.start();

console.log("start send signal: ======");
server.sendSignal("sayHello", "hello world.");
server.stop();

// another server
// var server2 = new dbus_wrap.DBusServer("iot.device.idle2", '/iot/device/idle2');
// server2.addMatch("type='signal',path='/iot/device/idle2',interface='iot.device.idle2'");
// server2.addMatch("type='method_call',path='/iot/device/idle2',interface='iot.device.idle2'");
// server2.on("method_call", function(method, args, callback) {
//     console.log("iot.device.idle2: get method call: " + method, " args is: " + args);
//     callback(2222, 'you are the best 2.');
// });
// server2.on("signal", function(signal, args) {
//     console.log("iot.device.idle2: get SIGNAL: " + signal + ' args: ' + args);
// });
