const Obj1 = function () {
  this.profile = {
    schema: 'http://aliyun/iot/thing/desc/schema',
    link: '/sys/q408EXte2fy/airCondition/thing/',
    profile: {
      productKey: 'obj1',
      deviceName: 'abcde',
    },
    properties: [
      {
        identifier: 'fan_int_property',
        name: '风扇整数型属性',
        accessMode: 'rw',
        required: true,
        dataType: {
          type: 'int',
          specs: {
            min: '0',
            max: '100',
            precise: '0',
            unit: 'g/ml',
            unitName: '毫升',
          },
        },
      },
      {
        identifier: 'fan_string_property',
        name: '风扇整数型属性',
        accessMode: 'rw',
        required: true,
        dataType: {
          type: 'int',
          specs: {
            min: '0',
            max: '100',
            precise: '0',
            unit: 'g/ml',
            unitName: '毫升',
          },
        },
      },
    ],

    events: [
      {
        identifier: 'post',
        name: 'post',
        type: 'info',
        required: true,
        desc: '属性上报',
        method: 'thing.event.property.post',
        outputData: [
          {
            identifier: 'fan_int_property',
            name: '风扇整数型属性',
            dataType: {
              type: 'int',
              specs: {
                min: '0',
                max: '100',
                precise: '0',
                unit: 'g/ml',
                unitName: '毫升',
              },
            },
          },
          {
            identifier: 'batch_enum_attr_id',
            name: '风扇枚举型属性',
            dataType: {
              type: 'enum',
              specs: {
                0: 'one',
                1: 'two',
                2: 'three',
              },
            },
          },
        ],
      },

    ],

    services: [
      {
        name: 'upgrade',
        identifier: 'upgrade',
        desc: '升级服务',
        inputData: [
          {
            identifier: 'model',
            name: '模型',
            dataType: {
              type: 'uint',
              specs: {
                min: '1',
                max: '100',
                unit: 'cm',
              },
            },
          },
          {
            identifier: 'mac',
            name: 'mac号',
            dataType: {
              type: 'text',
              specs: {
                length: '255',
              },
            },
          },
        ],
        outputData: [
          {
            identifier: 'firmVersion',
            name: '固件版本号',
            dataType: {
              type: 'uint',
              specs: {
                min: '1',
                max: '100',
                unit: '',
              },
            },
          },
        ],
        method: 'thing.service.upgrade',
      },
    ],
  };
};

module.exports = new Obj1();
